# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: Logon.tcl,v 1.8 2003/04/04 18:40:26 tsmith Exp $

#------------------------------------------------------------------#
# Module: LOGON  						   #
#	TCL code to allow GUI logon to McIDAS			   #
#------------------------------------------------------------------#
proc GUILogon { option } \
  {
  global Initials
  global ProjectNumber
  global LogonReturn
  
  set LogonReturn 0  ; # -1 cancel 0 OK/Continue 

  if { [winfo exists .wmLogon] } {wm deiconify .wmLogon; focus .wmLogon; return}
  
  toplevel .wmLogon
  wm title .wmLogon "Logon"
  frame .wmLogon.frameMain -relief raised -borderwidth 3
  label .wmLogon.frameMain.labelLogon -text "McIDAS Logon"
  frame .wmLogon.frameMain.frameEntry
  label .wmLogon.frameMain.frameEntry.labelInitials -text "Initials:" -anchor e
  entry .wmLogon.frameMain.frameEntry.entryInitials -textvariable Initials -relief sunken\
                                       -borderwidth 3 -highlightthickness 0 -width 4\
				       -background white
  label .wmLogon.frameMain.frameEntry.labelProject -text "Project Number:" -anchor e
  entry .wmLogon.frameMain.frameEntry.entryProject -textvariable ProjectNumber -relief sunken\
                                       -borderwidth 3 -highlightthickness 0 -width 4 \
				       -background white
  frame .wmLogon.frameMain.frameLogon -relief groove -borderwidth 3
  button .wmLogon.frameMain.frameLogon.buttonLogon -text "Logon" -command { VerifyAndLogon } -highlightthickness 0
  pack .wmLogon.frameMain.frameLogon.buttonLogon -side left -padx 20 -pady 10
  if { [string match $option "Continue" ] } \
    {
    button .wmLogon.frameMain.frameLogon.buttonContinue -text "Continue" -command { destroy .wmLogon } -highlightthickness 0
    pack .wmLogon.frameMain.frameLogon.buttonContinue -side left -padx 20 -pady 10
    }
  button .wmLogon.frameMain.frameLogon.buttonCancel -text "Cancel" -command { set LogonReturn -1; destroy .wmLogon } -highlightthickness 0
  pack .wmLogon.frameMain.frameLogon.buttonCancel -side left -padx 20 -pady 10

  pack .wmLogon.frameMain.frameEntry.labelInitials -side left
  pack .wmLogon.frameMain.frameEntry.entryInitials -side left
  pack .wmLogon.frameMain.frameEntry.labelProject -side left
  pack .wmLogon.frameMain.frameEntry.entryProject -side left  

  pack .wmLogon.frameMain.labelLogon -side top -pady 5
  pack .wmLogon.frameMain.frameEntry -side top -pady 5 -padx 15
  pack .wmLogon.frameMain.frameLogon -side top -pady 15
  pack .wmLogon.frameMain
  
  bind .wmLogon.frameMain.frameEntry.entryInitials <KeyPress> { set Initials [string toupper $Initials] }
  bindtags .wmLogon.frameMain.frameEntry.entryInitials [list Entry . .wmLogon.frameMain.frameEntry.entryInitials all ]
  
  focus .wmLogon.frameMain.frameEntry.entryInitials
  
  tkwait window .wmLogon
  return $LogonReturn
  }
#--------------------------------------------------------------------------#
# VerifyAndLogon -- makes sure variables are entered and then logs on      #
#--------------------------------------------------------------------------#
proc VerifyAndLogon { } \
  {
  global Initials
  global ProjectNumber
  global tk_version

  # Tk widget commands moved to namespaces with version 8.1 and higher
  # Expose the old private Tk commands.
  if { $tk_version >= 8.1 } \
  {
	::tk::unsupported::ExposePrivateCommand tk*
  }  


  #-- After the logon need to update MyImageSelect info if present
  #-- kind of strange but open a pipe to logon.k so can get the response back
  set Initials [string toupper $Initials]
  set ProjectNumber [string toupper $ProjectNumber]
  set response [open "|logon.k $Initials $ProjectNumber X WS" r]
    
  # -- LOGON in progress  
  gets $response line
  # -- this should read "LOGON to McIDAS-X completed."
  gets $response line
  if { [string match "LOGON to McIDAS-X completed." $line] } \
    {
    destroy .wmLogon
    }\
  else \
    {
    tk_messageBox  -title "LOGON Failed" -message "Logon failed: Please re-enter initials and project number."\
                   -type ok -parent .  -icon warning   		
    }  
  # -- Burn up the rest  
  catch { close $response }
  }  
  
