# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: bindit.tcl,v 1.3 1998/10/13 20:26:23 dglo Exp $

# bindit
#
# Bind certain key presses in entry widgets.
#
# Arguments:
#
#	level		corresponds to three possible arrays of
#			widgets to bind: entries1, entries2 or entries3
#
#
proc bindit {level} {
#
#	Point at the right entries array.
#
	set name [format "entries%s" $level]
	upvar  1 $name elements
#
#	Bind depending on how many things in the array.
#
	set num_entry [array size elements]

	if { $num_entry == 0 } {
		return
	} else {
		if { $num_entry == 1 } {
			bind $elements(0) <Return> " focus $elements(0)"
			bind $elements(0) <Tab> " focus $elements(0)"
			bind $elements(0) <Shift-Tab> " focus $elements(0)"
			return
		}
	}
#
#	Key presses move focus from one entry to the next.
#
	set last $num_entry
	for {set i 0} { $i < $num_entry} {incr i} {
		if { $i == [expr $num_entry -1] } {
			bind $elements($i) <Tab> "focus $elements(0)"
			bind $elements($i) <Return> "focus $elements(0)"
			bind $elements($i) <Shift-Tab> \
				"focus $elements([expr $i-1])"
		} else {
			bind $elements($i) <Tab> "focus $elements([expr $i+1])"
			bind $elements($i) <Return> \
				"focus $elements([expr $i+1])"
			if { $i == 0 } {
				bind $elements($i) <Shift-Tab> \
					"focus $elements([expr $last-1]) "
			} else {
				bind $elements($i) <Shift-Tab> \
					"focus $elements([expr $i-1])"
			}
		}
	}
}
