# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: listcol.tcl,v 1.11 1998/10/13 20:26:39 dglo Exp $

proc listcol {{type}} {

#
#	listcol - list a box of current color settings and
#	paint a swatch with the usesr's selection
#
	global widgetname
	global widgetname2
	global guipath

#
#	Let user know this will take a while.
#
	showBusyStatus

	set map 1
	set cont 2
	catch {destroy .colors}
	toplevel .colors
	wm title .colors "Color "
	wm minsize .colors  1 1
	placepopup .colors
	button .colors.dismiss -command "destroy .colors" -text "Dismiss" \
		-width 10
	pack    .colors.dismiss  -side bottom -fill both
	canvas .colors.canvas -yscrollcommand ".colors.scroll set "\
		-scrollregion {0 0 0 650}\
		-confine false
	pack    .colors.canvas -side left -fill both -expand true

	set hold .colors.canvas
	bind .colors.canvas <Configure> "config %w %h"

	scrollbar .colors.scroll -command \
		".colors.canvas yview" -orient vertical

#	pack    .colors.scroll -side left  -fill y

	set guout [open "|gu.k TAB " r]
	while {[gets $guout guline] > -1} {
		set level [string range $guline 3 4]
		if {$level <= 9} { set level [string range $guline 4 4]}
		set red [string range $guline 35 38]
		set green [string range $guline 31 33]
		set blue [string range $guline 24 26]
		if {$level >= 0 && $level <= [UCpeek number_graphics]} {
			set rgb [format "#%02x%02x%02x" $red $green $blue]
			frame $hold.lev$level
			button $hold.lev$level.button \
				-bitmap @[bitmapLoc box.xbm] \
				-foreground $rgb \
				-command "set color $level;

					if {$type == $map} {

						set mlev $level

					#-------
					# make the parent frame this color
					#-------

						$widgetname2 configure -bg $rgb

					} elseif {$type == $cont} {

						set clev $level

					#-------
					# make the parent frame this color
					#-------

						$widgetname configure -bg $rgb

					}

					  destroy .colors"\
				-background gray\
				-activeforeground $rgb
			label $hold.lev$level.label -text $level

			.colors.canvas create window 1 [expr $level *30]\
				-anchor w\
				-window $hold.lev$level

			pack append $hold.lev$level\
				$hold.lev$level.label {left}\
				$hold.lev$level.button {right}
			pack append $hold \
				$hold.lev$level	{top fill}
		}
	}
	pack $hold -side top
	catch {close $guout}
#	pack	.colors -side top -fill both
	pack	.colors.dismiss  -side bottom -fill both

	set child [lindex [pack slaves .colors.canvas] 0]
	tkwait visibility $child

	set hgt [winfo height .colors.canvas]
	set wid [winfo width .colors.canvas]
	.colors.canvas configure -scrollregion "0 0 $wid $hgt"
	.colors.canvas config -width $wid -height  $hgt


#
#	Let user know we're done.
#
	showIdleStatus
}

proc config {w h} {
	.colors.canvas configure -scrollregion "0 0 $w $h"
}
