# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: listgroup.tcl,v 1.12 1998/10/13 20:26:41 dglo Exp $

# ListGroup w
#
# Create a top-level window containing a listbox showing a bunch of
# ADDE group names
#
# Arguments:
#
#    w		Name to use for new top-level window.
#

proc ListGroup { nextproc datatype getpos thevar {w .listgroup}} {

#
#	Let user know this will take a while.
#
	showBusyStatus
#
#	Create a popup widget for listing ADDE group names.
#
	catch {destroy $w}
	toplevel $w
	wm title $w "ADDE Groups"
	wm iconname $w "ADDE"
	wm minsize $w 1 1
	placepopup $w
	message $w.msg -font -Adobe-times-medium-r-normal--*-180* -aspect 900 \
	    -text "Double click to select group."

	frame $w.frame -borderwidth 10
	scrollbar $w.frame.scroll -relief sunken -command "$w.frame.list yview"
	listbox $w.frame.list -yscroll "$w.frame.scroll set" -relief sunken \
		-width 60 -height 10 -setgrid 1

	pack append $w.frame $w.frame.scroll {right filly} \
		$w.frame.list {left expand fill}
#
#	Get the table names and put them in the listbox.
#
	set lalist [open "|dataloc.k LIST" r]
	gets $lalist temp
	gets $lalist temp
	set lab2 [string range $temp 0 20]
	label $w.label2 -width 42 -text $lab2
	gets $lalist lab3
	while {[gets $lalist line] > -1} {
#
#		Don't put the Done message into the box.
#
		if {[string first done $line] == -1} {
		if {[string first indicate $line] == -1} {
#
#			Don't put the linked message into the box.
#
			if { [string first linked $line] == -1} {
#
#				Extract the file name.  Insert in listbox.
#
				set filename [string range $line 0 80]
				$w.frame.list insert end $filename
			}
		}
		}
	}
	catch {close $lalist}
#
#	Select a table by double clicking.
#
	bind $w.frame.list <Double-1> \
		{set areal [selection get]
		 set group [string range $areal 0 \
		       [expr [string first " " $areal ] -1 ] ]

		 destroy .listgroup

		 if {$nextproc != "" && $nextproc != " "} {
		    $nextproc $group $datatype $getpos $thevar
		 }
	}
#
#	Dismiss button.
#
	button $w.ok -text Dismiss -command "destroy $w" -width 20

	pack $w.msg -side top -fill both
	pack $w.label2 -side top
	pack $w.frame -side top
	pack $w.ok -side bottom
#
#	Let user know we're done.
#
	showIdleStatus
}
