# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: pickfrange.tcl,v 1.13 1998/10/13 20:26:45 dglo Exp $

# Create a top-level window containing a listbox showing a bunch of
# McIDAS frames
#
# Arguments:



proc pickfrange {{type 0}} {
    catch {destroy .range}
    toplevel .range
    wm title .range "Frame Listing"
    wm iconname .range "Frame"
    wm minsize .range 1 1
    placepopup .range
    global dframe
    global bframe
    global eframe
    message .range.msg -font -Adobe-times-medium-r-normal--*-180* -aspect 700 \
	    -relief flat -text "Double click to select a single frame.
Select a range of frames by dragging the mouse
to highlight the frames."
    frame .range.frame -borderwidth 10
    scrollbar .range.frame.scroll -relief sunken -command ".range.frame.list yview"
    listbox .range.frame.list -yscroll ".range.frame.scroll set" -relief sunken \
	    -width 82 -height 10 -setgrid 1 -selectmode extended
    pack append .range.frame .range.frame.scroll {right filly} \
	    .range.frame.list {left expand fill}
set totframes [UCpeek number_of_frames]
set lflist [open "|frmlist.k 1 $totframes" r]
gets $lflist lab1
label .range.label1 -width 84 -text $lab1 -anchor w
gets $lflist lab2
label .range.label2 -width 84 -text $lab2 -anchor w
gets $lflist junk
while {[gets $lflist line] > -1} {
	if { [string first Done $line] == -1} {
	.range.frame.list insert end  $line }
}
catch {close $lflist}
bind .range.frame.list <Double-1> \
     {set dframel [selection get]
      set dframe [string range $dframel 2 5]
      set bframe $dframe
      set eframe $dframe
     destroy .range}

    frame .range.bottom
    button .range.bottom.dismiss -text Dismiss -command "destroy .range" -width 10
    button .range.bottom.ok -text "OK" -width 10 -command {
		set ilist [.range.frame.list curselection]
		set first [lindex $ilist 0]
		set fframel [.range.frame.list get $first]
		set bframe [string range $fframel 2 5]
		set bframe [string trim $bframe]
		set ilast [expr [llength $ilist] -1]
		set last [lindex $ilist $ilast]
		set lframel [.range.frame.list get $last]
		set eframe [string range $lframel 2 5]
		set eframe [string trim $eframe]
		destroy .range
	}

pack append .range.bottom	\
	.range.bottom.ok	{left padx 10 pady 10 expand}\
	.range.bottom.dismiss   {right padx 10 pady 10 expand}
pack .range.msg -side top -fill x
pack .range.label1 -side top
pack .range.label2 -side top
pack .range.frame -side top
pack .range.bottom -side bottom -fill x -expand yes
}
