# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: routecomm.tcl,v 1.6 1998/10/13 20:26:47 dglo Exp $

#	RouteCommand command
#
#	Run a McIDAS command , sending output to a listbox
#
#	Arguments:
#		command - command string to enter
#



proc RouteComm {command headsize} {

#
#	Let user know this will take a while.
#
	showBusyStatus

	catch {destroy .command}
	set blank [string first " " $command]
	set name [string range $command 0 [expr $blank - 1 ] ]

	toplevel .command
	wm title .command Output
	wm minsize .command 1 1
	placepopup .command
	frame .command.frame
	scrollbar .command.frame.scroll -relief sunken \
		-command ".command.frame.listbox yview"
	listbox .command.frame.listbox -yscroll ".command.frame.scroll set" \
		-relief sunken -width 80 -height 15
	pack append .command.frame \
		.command.frame.scroll {right filly} \
		.command.frame.listbox {left expand fill}

	set lowname [string tolower $name]
	set executable [format "%s.k" $lowname]
	set blank [string first " " $command]
	set restoline [string range $command $blank end]
	set execout [open "|$executable $restoline " r]
	for {set i 0} { $i < $headsize} {incr i} {
		gets $execout lab($i)
		set length [string length $lab($i)]
		label .command.label$i -text $lab($i) -width $length
		pack .command.label$i -side top -anchor w
	}
	while {[gets $execout line] > -1} {
		if { [string first COMPLETE $line] == -1 &&
		     [string first DONE $line] == -1 } then {
			.command.frame.listbox insert end $line
		}
	}
	catch {close $execout}

	button .command.dismiss -text Dismiss -command "destroy .command"
	pack .command.frame	-side top -fill x
	pack .command.dismiss	-side bottom
#
#	Let user know we're done.
#
	showIdleStatus
}
