proc initUserCommon {} {
  global ucNameMap
  set ucNameMap(current_frame_snap) -1
  set ucNameMap(current_graphic_snap) -5
  set ucNameMap(sdest_key) -31
  set ucNameMap(edest_key) -32
  set ucNameMap(ddest_key) -33
  set ucNameMap(sdest_fd) -35
  set ucNameMap(edest_fd) -36
  set ucNameMap(ddest_fd) -37
  set ucNameMap(panel) -40
  set ucNameMap(twin) -45
  set ucNameMap(tcol) -46
  set ucNameMap(user_initials) 2
  set ucNameMap(navfile) 4
  set ucNameMap(mdfile) 5
  set ucNameMap(gridfile) 6
  set ucNameMap(fixed_linesize) 11
  set ucNameMap(fixed_elesize) 12
  set ucNameMap(number_of_frames) 13
  set ucNameMap(number_of_graphics) 14
  set ucNameMap(video) 16
  set ucNameMap(latlon_format) 17
  set ucNameMap(g_key) 20
  set ucNameMap(q_key) 21
  set ucNameMap(terminal_type) 37
  set ucNameMap(gra_width) 46
  set ucNameMap(gra_dash_len) 47
  set ucNameMap(gra_gap_len) 48
  set ucNameMap(gra_dash_lev) 49
  set ucNameMap(looping) 50
  set ucNameMap(current_frame) 51
  set ucNameMap(loop_upper_bound) 52
  set ucNameMap(loop_lower_bound) 53
  set ucNameMap(frames_movable) 54
  set ucNameMap(frame_visible) 55
  set ucNameMap(current_graphic) 56
  set ucNameMap(graphic_movable) 59
  set ucNameMap(graphic_visible) 60
  set ucNameMap(cursor_vert_size) 61
  set ucNameMap(cursor_horiz_size) 62
  set ucNameMap(cursor_line) 63
  set ucNameMap(cursor_element) 64
  set ucNameMap(cursor_type) 65
  set ucNameMap(cursor_color) 66
  set ucNameMap(number_of_text_windows) 140
  set ucNameMap(ignore_signals) 142
  set ucNameMap(command_window_id) 143
  set ucNameMap(image_window_id) 144
  set ucNameMap(volnam_offset) 145
  set ucNameMap(fontflag) 150
  set ucNameMap(windco_cursor) 164
  set ucNameMap(windco_sampling) 165
  set ucNameMap(windco_active) 166
  set ucNameMap(comm_connect) 177
  set ucNameMap(ignore_mouse_button_press) 178
  set ucNameMap(mouse_button_status) 185
  set ucNameMap(host_mode) 189
  set ucNameMap(export_request_pointer) 192
  set ucNameMap(export_complete_pointer) 193
  set ucNameMap(import_complete_pointer) 197
  set ucNameMap(import_request_pointer) 199
  set ucNameMap(shutdown_system) 194
  set ucNameMap(comm_port_name) 198
  set ucNameMap(current_text_window) 200
  set ucNameMap(mouse_raw_y) 202
  set ucNameMap(mouse_raw_x) 203
  set ucNameMap(last_frame_displayed) 204
  set ucNameMap(restricted_session) 208
  set ucNameMap(gui_cmd_history) 210
  set ucNameMap(gui_cmd_echo) 211
  set ucNameMap(combine_port) 215
  set ucNameMap(zoom_toggle) 300
  set ucNameMap(briefing_port) 315
  set ucNameMap(number_graphics) 500
  set ucNameMap(interpolation_mode) 501
  set ucNameMap(image_window_resize) 502
  set ucNameMap(zoom_factor) 503
  set ucNameMap(image_window_process) 504
  set ucNameMap(update_cursor_info) 550
  set ucNameMap(cursor_panel) 551
  set ucNameMap(cursor_panel_line) 552
  set ucNameMap(cursor_panel_elem) 553
  set ucNameMap(cursor_latitude) 554
  set ucNameMap(cursor_longitude) 555
  set ucNameMap(modified_frame_dir) 556
  set ucNameMap(panel_magic_number) 560
  set ucNameMap(number_image_colors) 600
  set ucNameMap(tcp_loaded) 700
  set ucNameMap(import_loaded) 701
  set ucNameMap(cursor_brightness) 1900
  set ucNameMap(image_window_raise) 2000
  set ucNameMap(text_window_raise) 3000
  set ucNameMap(video_offsets) 2000
  set ucNameMap(frame_sizes) 3000
  set ucNameMap(loop_control) 4000
  set ucNameMap(dwell_rates) 5000
  set ucNameMap(graphic_control) 6000
  set ucNameMap(opposite_seq) 7000
  set ucNameMap(avail_q) 8000
  set ucNameMap(q_head) 8000
  set ucNameMap(q_tail) 9000
  set ucNameMap(graphic_mask) 10000
}

proc ucLocation { name } {
  global ucNameMap

  if ![info exists ucNameMap] {
    initUserCommon
  }

  if [info exists ucNameMap($name)] {
    return $ucNameMap($name)
  }

  if ![catch {set v [expr $name + 0]}] {
    return $name
  }

  error "Unknown UC location \"$name\""
}
