#!/bin/false

# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: initbblite.tcl,v 1.20 2004/06/21 16:47:31 tsmith Exp $

setoptions

proc initFileButtons {buttonbar} \
{
   global popup_help_text
   global env

   # Create 'open' and 'save' button icons
   set open_file_image [image create photo \
					-data {
R0lGODlhFAAUAPcAAAAAADMAAGYAAJkAAMwAAP8AAAAzADMzAGYzAJkzAMwzAP8zAABmADNm
AGZmAJlmAMxmAP9mAACZADOZAGaZAJmZAMyZAP+ZAADMADPMAGbMAJnMAMzMAP/MAAD/ADP/
AGb/AJn/AMz/AP//AAAAMzMAM2YAM5kAM8wAM/8AMwAzMzMzM2YzM5kzM8wzM/8zMwBmMzNm
M2ZmM5lmM8xmM/9mMwCZMzOZM2aZM5mZM8yZM/+ZMwDMMzPMM2bMM5nMM8zMM//MMwD/MzP/
M2b/M5n/M8z/M///ewAAZjMAZmYAZpkAZswAZv8AZgAzZjMzZmYzZpkzZswzZv8zZgBmZjNm
ZmZmZplmZsxmZv9mZgCZZjOZZmaZZpmZZsyZZv+ZZgDMZjPMZmbMZpnMZszMZv/MZgD/ZjP/
Zmb/Zpn/Zsz/Zv//ZgAAmTMAmWYAmZkAmcwAmf8AmQAzmTMzmWYzmZkzmcwzmf8zmQBmmTNm
mWZmmZlmmcxmmf9mmQCZmTOZmWaZmZmZmcyZmf+ZmQDMmTPMmWbMmZnMmczMmf/MmQD/mTP/
mWb/mZn/mcz/mf//mQAAzDMAzGYAzJkAzMwAzP8AzAAzzDMzzGYzzJkzzMwzzP8zzABmzDNm
zGZmzJlmzMxmzP9mzACZzDOZzGaZzJmZzMyZzP+ZzADMzDPMzGbMzJnMzMzMzP/MzAD/zDP/
zGb/zJn/zMz/zP//zAAA/zMA/2YA/5kA/8wA//8A/wAz/zMz/2Yz/5kz/8wz//8z/wBm/zNm
/2Zm/5lm/8xm//9m/wCZ/zOZ/2aZ/5mZ/8yZ//+Z/wDM/zPM/2bM/5nM/8zM///M/wD//zP/
/2b//5n//8z//////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAANcALAAAAAAUABQAQAhbAK8JHEiwoMFr
AB4pXLgQwMGHECMOdCjQIcWJCgFU2MiR40WJIBEC+EhwJMmEDU2qNFlSY8eOJEPKnBmRJc2W
BVE+WjkSok6GGX02fAkz506iHg/yXHmzKciAAAA7
						   }]

   set save_file_image [image create photo \
					-data {
R0lGODlhFAAUAPcAAAAAADMAAGYAAJkAAMwAAP8AAAAzADMzAGYzAJkzAMwzAP8zAABmADNm
AGZmAJlmAMxmAP9mAACZADOZAGaZAJmZAMyZAP+ZAADMADPMAGbMAJnMAMzMAP/MAAD/ADP/
AGb/AJn/AMz/AP//AAAAMzMAM2YAM5kAM8wAM/8AMwAzMzMzM2YzM5kzM8wzM/8zMwBmMzNm
M2ZmM5lmM8xmM/9mMwCZMzOZM2aZM5mZM8yZM/+ZMwDMMzPMM2bMM5nMM8zMM//MMwD/MzP/
M2b/M5n/M8z/M///MwAAZjMAZmYAZpkAZswAZv8AZgAzZjMzZmYzZpkzZswzZv8zZgBmZjNm
ZmZmZplmZsxmZv9mZgCZZjOZZmaZZpmZZsyZZv+ZZgDMZjPMZmbMZpnMZszMZv/MZgD/ZjP/
Zmb/Zpn/Zsz/Zv//ZgAAmTMAmWYAmZkAmcwAmf8AmQAzmTMzmWYzmZkzmcwzmf8zmQBmmTNm
mWZmmZlmmcxmmf9mmQCZmTOZmWaZmZmZmcyZmf+ZmQDMmTPMmWbMmZnMmczMmf/MmQD/mTP/
mWb/mZn/mcz/mf//mQAAzDMAzGYAzJkAzMwAzP8AzAAzzDMzzGYzzJkzzMwzzP8zzABmzDNm
zGZmzJlmzMxmzP9mzACZzDOZzGaZzJmZzMyZzP+ZzADMzDPMzGbMzJnMzMzMzP/MzAD/zDP/
zGb/zJn/zMz/zP//zAAA/zMA/2YA/5kA/8wA//8A/wAz/zMz/2Yz/5kz/8wz//8z/wBm/zNm
/2Zm/5lm/8xm//9m/wCZ/zOZ/2aZ/5mZ/8yZ//+Z/wDM/zPM/2bM/5nM/8zM///M/wD//zP/
/2b//5n//8z//////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAANcALAAAAAAUABQAQAhqAK8JHEiwoEGB
ACoAYMWwIcOEAA4CmEixIkWDEB06XBixYEKFFikqPEiyJEKFGhtCxFgBZMiWHQl+DPlwpMmb
OHGG3BlzYMaUrC56RAl05dCFRW3KbMm0KdOeJ11SrAn12kyLVHNq3XotIAA7
						  }]

   set exit_image [image create photo \
				-data {
R0lGODlhFAAUAPcAAAAAAAEBAQICAgMDAwQEBAUFBQYGBgcHBwgICAkJCQoKCgsLCwwMDA0N
DQ4ODg8PDxAQEBERERISEhMTExQUFBUVFRYWFhcXFxgYGBkZGRoaGhsbGxwcHB0dHR4eHh8f
HyAgICEhISIiIiMjIyQkJCUlJSYmJicnJygoKCkpKSoqKisrKywsLC0tLS4uLi8vLzAwMDEx
MTIyMjMzMzQ0NDU1NTY2Njc3Nzg4ODk5OTo6Ojs7Ozw8PP8AAD4+Pj8/P0BAQEFBQUJCQkND
Q0REREVFRUZGRkdHR0hISElJSUpKSktLS0xMTE1NTU5OTk9PT1BQUFFRUVJSUlNTU1RUVFVV
VVZWVldXV1hYWFlZWVpaWltbW1xcXF1dXV5eXl9fX2BgYGFhYWJiYmNjY2RkZGVlZWZmZmdn
Z2hoaGlpaWpqamtra2xsbG1tbf//AG9vb3BwcHFxcXJycnNzc3R0dHV1dXZ2dnd3d3h4eHl5
eXp6ent7e3x8fH19fX5+fn9/f4CAgIGBgYKCgoODg4SEhIWFhYaGhoeHh4iIiImJiYqKiouL
i4yMjI2NjY6Ojo+Pj5CQkJGRkZKSkpOTk5SUlJWVlZaWlpeXl5iYmJmZmZqampubm5ycnJ2d
nZ6enp+fn6CgoKGhoaKioqOjo6SkpKWlpaampqenp6ioqKmpqaqqqqurq6ysrK2tra6urq+v
r7CwsLGxsbKysrOzs7S0tLW1tba2tre3t7i4uLm5ubq6uru7u7y8vL29vb6+vr+/v8DAwMHB
wcLCwsPDw8TExMXFxcbGxsfHx8jIyMnJycrKysvLy8zMzM3Nzc7Ozs/Pz9DQ0NHR0dLS0tPT
09TU1NXV1dbW1tfX19jY2NnZ2dra2tvb29zc3N3d3d7e3t/f3+Dg4OHh4eLi4uPj4+Tk5OXl
5ebm5ufn5+jo6Onp6erq6uvr6+zs7O3t7e7u7u/v7/Dw8PHx8fLy8vPz8/T09PX19fb29vf3
9/j4+Pn5+fr6+vv7+/z8/P39/f7+/v///yH5BAEAAM4ALAAAAAAUABQAAAhbAJ0JHEiwoMGD
CBMqVAigocOGC505/EfxH4CIDyteXPiwocWBPRB2BPDRWY+TB0d+DMnSoMqNJkV2LBkzZceT
OBNOtEhT50yYPjMCLTiy6FCbRzEmjci06cCAAAA7
						}]
				

   # Create frame for 'open' and 'save' buttons
   frame $buttonbar.fileFrame \
	-relief ridge \
	-borderwidth 2
   pack $buttonbar.fileFrame \
	-side left \
	-padx 5

   # Create buttons
   button $buttonbar.fileFrame.openButton \
	-image $open_file_image \
	-height 21 \
	-width 21 \
	-command { FileSelector "$env(MCLITE_INSTALL)/data" }
   pack $buttonbar.fileFrame.openButton \
	-side left

   button $buttonbar.fileFrame.saveButton \
	-image $save_file_image \
	-height 21 \
	-width 21 \
	-command {execGUI frmsavelite}
   pack $buttonbar.fileFrame.saveButton \
	-side left

   button $buttonbar.fileFrame.exitButton \
	-image $exit_image \
	-height 21 \
	-width 21 \
	-command {exitGUI "McIDAS" {SaveContext
							SaveServerLists
							mcidas poke 194 1}}
   pack $buttonbar.fileFrame.exitButton \
	-side left

   # Set popup help text for file buttons
   set popup_help_text($buttonbar.fileFrame.openButton) "Open File"
   set popup_help_text($buttonbar.fileFrame.saveButton) "Save File"
   set popup_help_text($buttonbar.fileFrame.exitButton) "Exit McIDAS-Lite"
}

proc initZoomButtons {buttonbar} \
{
   global zoom_factor
   global popup_help_text
   global env


   # Create zoom in and zoom out button icons
   set zoom_in_image [image create photo \
				-data {
R0lGODlhFAAUAPcAAAAAADMAAGYAAJkAAMwAAP8AAAAzADMzAGYzAJkzAMwzAP8zAABmADNm
AGZmAJlmAMxmAP9mAACZADOZAGaZAJmZAMyZAP+ZAADMADPMAGbMAJnMAMzMAP/MAAD/ADP/
AGb/AJn/AMz/AP//AAAAMzMAM2YAM5kAM8wAM/8AMwAzMzMzM2YzM5kzM8wzM/8zMwBmMzNm
M2ZmM5lmM8xmM/9mMwCZMzOZM2aZM5mZM8yZM/+ZMwDMMzPMM2bMM5nMM8zMM//MMwD/MzP/
M2b/M5n/M8z/M///MwAAZjMAZmYAZpkAZswAZv8AZgAzZjMzZmYzZpkzZswzZv8zZgBmZjNm
ZmZmZplmZsxmZv9mZgCZZjOZZmaZZpmZZsyZZv+ZZgDMZjPMZmbMZpnMZszMZv/MZgD/ZjP/
Zmb/Zpn/Zsz/Zv//ZgAAmTMAmWYAmZkAmcwAmf8AmQAzmTMzmWYzmZkzmcwzmf8zmQBmmTNm
mWZmmZlmmcxmmf9mmQCZmTOZmWaZmZmZmcyZmf+ZmQDMmTPMmWbMmZnMmczMmf/MmQD/mTP/
mWb/mZn/mcz/mf//mQAAzDMAzGYAzJkAzMwAzP8AzAAzzDMzzGYzzJkzzMwzzP8zzABmzDNm
zGZmzJlmzMxmzP9mzACZzDOZzGaZzJmZzMyZzP+ZzADMzDPMzGbMzJnMzMzMzP/MzAD/zDP/
zGb/zJn/zMz/zP//zAAA/zMA/2YA/5kA/8wA//8A/wAz/zMz/2Yz/5kz/8wz//8z/wBm/zNm
/2Zm/5lm/8xm//9m/wCZ/zOZ/2aZ/5mZ/8yZ//+Z/wDM/zPM/2bM/5nM/8zM///M/wD//zP/
/2b//5n//8z//////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAANcALAAAAAAUABQAQAh/AK8JHEiwoMFr
/1Y9WwigmkNW/w5KNPhvhZWIBFdY27ixGqAVEwv+GynwnxWIIa+tWIEx5T9WHBs+bHlwBSBr
zxx6pJlSpEWUPYMKrfnSGkSQLmNaq2aNZ0GNTf8BGMnUKcF/1lRVk1nN6tOiqyqO9Dqx4kmy
Es0CHUpy6MGAAAA7
					  }]

   set zoom_out_image [image create photo \
				-data {
R0lGODlhFAAUAPcAAAAAADMAAGYAAJkAAMwAAP8AAAAzADMzAGYzAJkzAMwzAP8zAABmADNm
AGZmAJlmAMxmAP9mAACZADOZAGaZAJmZAMyZAP+ZAADMADPMAGbMAJnMAMzMAP/MAAD/ADP/
AGb/AJn/AMz/AP//AAAAMzMAM2YAM5kAM8wAM/8AMwAzMzMzM2YzM5kzM8wzM/8zMwBmMzNm
M2ZmM5lmM8xmM/9mMwCZMzOZM2aZM5mZM8yZM/+ZMwDMMzPMM2bMM5nMM8zMM//MMwD/MzP/
M2b/M5n/M8z/M///MwAAZjMAZmYAZpkAZswAZv8AZgAzZjMzZmYzZpkzZswzZv8zZgBmZjNm
ZmZmZplmZsxmZv9mZgCZZjOZZmaZZpmZZsyZZv+ZZgDMZjPMZmbMZpnMZszMZv/MZgD/ZjP/
Zmb/Zpn/Zsz/Zv//ZgAAmTMAmWYAmZkAmcwAmf8AmQAzmTMzmWYzmZkzmcwzmf8zmQBmmTNm
mWZmmZlmmcxmmf9mmQCZmTOZmWaZmZmZmcyZmf+ZmQDMmTPMmWbMmZnMmczMmf/MmQD/mTP/
mWb/mZn/mcz/mf//mQAAzDMAzGYAzJkAzMwAzP8AzAAzzDMzzGYzzJkzzMwzzP8zzABmzDNm
zGZmzJlmzMxmzP9mzACZzDOZzGaZzJmZzMyZzP+ZzADMzDPMzGbMzJnMzMzMzP/MzAD/zDP/
zGb/zJn/zMz/zP//zAAA/zMA/2YA/5kA/8wA//8A/wAz/zMz/2Yz/5kz/8wz//8z/wBm/zNm
/2Zm/5lm/8xm//9m/wCZ/zOZ/2aZ/5mZ/8yZ//+Z/wDM/zPM/2bM/5nM/8zM///M/wD//zP/
/2b//5n//8z//////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAANcALAAAAAAUABQAQAh6AK8JHEiwoMFr
/1Y9W1itYTVW/w5KNPhvhZWIBFdY27ixGqAVEwv+GynwnxWIIa+tWIEx5T9WHK05RDlxBSBr
zxwCapmSokWaPYMKNcgSJkSQLmPKtMaT6MaRAEZWYxrynzVVDhs2PVjU2qqKI7e6/Cm2Ktmh
JcsODQgAOw==
					  }]

   set zoom_1to1_image [image create photo \
					-data {
R0lGODlhFQAVAPcAAAAAAAEBAQICAgMDAwQEBAUFBQYGBgcHBwgICAkJCQoKCgsLCwwMDA0N
DQ4ODg8PDxAQEBERERISEhMTExQUFBUVFRYWFhcXFxgYGBkZGRoaGhsbGxwcHB0dHR4eHh8f
HyAgICEhISIiIiMjIyQkJCUlJSYmJicnJygoKCkpKSoqKisrKywsLC0tLS4uLi8vLzAwMDEx
MTIyMjMzMzQ0NDU1NTY2Njc3Nzg4ODk5OTo6Ojs7Ozw8PD09PT4+Pj8/P0BAQEFBQUJCQkND
Q0REREVFRUZGRkdHR0hISPIcRkpKSktLS0xMTE1NTU5OTk9PT1BQUFFRUVJSUlNTU1RUVFVV
VVZWVldXV1hYWFlZWVpaWltbW1xcXF1dXV5eXl9fX2BgYGFhYWJiYmNjY2RkZGVlZWZmZmdn
Z2hoaGlpaWpqamtra2xsbG1tbW5ubm9vb3BwcHFxcXJycnNzc3R0dHV1dXZ2dnd3d3h4eHl5
eXp6ent7e3x8fH19fX5+fn9/f4CAgIGBgYKCgoODg4SEhIWFhYaGhoeHh4iIiImJiYqKiouL
i4yMjI2NjY6Ojo+Pj5CQkJGRkZKSkpOTk5SUlJWVlZaWlpeXl5iYmJmZmZqampubm5ycnJ2d
nZ6enp+fn6CgoKGhoaKioqOjo6SkpKWlpaampqenp6ioqKmpqaqqqqurq6ysrK2tra6urq+v
r7CwsLGxsbKysrOzs7S0tLW1tba2tre3t7i4uLm5ubq6uru7u7y8vL29vb6+vr+/v8DAwMHB
wcLCwsPDw8TExMXFxcbGxsfHx8jIyMnJycrKysvLy8zMzM3Nzc7Ozs/Pz9DQ0NHR0dLS0tPT
09TU1NXV1dbW1tfX19jY2NnZ2dra2tvb29zc3N3d3d7e3t/f3+Dg4OHh4eLi4uPj4+Tk5OXl
5ebm5ufn5+jo6Onp6erq6uvr6+zs7O3t7e7u7u/v7/Dw8PHx8fLy8vPz8/T09PX19fb29vf3
9/j4+Pn5+fr6+vv7+/z8/P39/f7+/v///yH5BAEAAP4ALAAAAAAVABUAQAhIAP0JHEiwoEGC
AAAMTIhQ4cGHECNKbLjQoUCGEzNqjIjxYMeCH0FaFAkx5MaTKFOqTGjSH8uRFC+ObOkSZkyD
HT/SVMmTZ0AAADs=
						   }]

   set zoom_factor 1
  
   frame $buttonbar.zoomFrame \
	-relief ridge \
	-borderwidth 2
   pack $buttonbar.zoomFrame \
	-side left \
	-padx 5

   button $buttonbar.zoomFrame.zoomIn \
	-image $zoom_in_image \
	-height 21 \
	-width 21 \
	-command "MODIFY_ZOOM_STATUS IN $buttonbar"
   pack $buttonbar.zoomFrame.zoomIn \
	-side left

   button $buttonbar.zoomFrame.zoomOut \
	-image $zoom_out_image \
	-height 21 \
	-width 21 \
	-command "MODIFY_ZOOM_STATUS OUT $buttonbar"
   pack $buttonbar.zoomFrame.zoomOut \
	-side left

   button $buttonbar.zoomFrame.reset \
	-image $zoom_1to1_image \
	-height 21 \
	-width 21 \
	-command "MODIFY_ZOOM_STATUS RESET $buttonbar"  
   pack $buttonbar.zoomFrame.reset \
	-side left

   # Set popup help text for zoom buttons
   set popup_help_text($buttonbar.zoomFrame.zoomIn) "Zoom In"
   set popup_help_text($buttonbar.zoomFrame.zoomOut) "Zoom Out"
   set popup_help_text($buttonbar.zoomFrame.reset) "Reset Zoom to 1:1"

   # Set initial status of 'zoom-out' and 'Reset' buttons to disabled
   $buttonbar.zoomFrame.zoomOut configure \
	-foreground grey \
	-state disabled

   $buttonbar.zoomFrame.reset configure \
	-foreground grey \
	-state disabled
}

proc MODIFY_ZOOM_STATUS {action buttonbar} \
{
   global zoom_factor


   if {[string compare $action "IN"] == 0} \
   {
	incr zoom_factor
	if {$zoom_factor > 6} {set zoom_factor 6}
	mcidas exec "ZM $zoom_factor"
	mcidas exec "TERM Z ON"
   } \
   elseif {[string compare $action "OUT"] == 0} \
   {
	incr zoom_factor -1
	if {[expr {$zoom_factor < 1}]} {set zoom_factor 1}
	if {[expr {$zoom_factor == 1}]} \
	{
		mcidas exec "TERM Z OFF"
	} \
	else \
	{
		mcidas exec "ZM $zoom_factor"
	}
   } \
   elseif {[string compare $action "RESET"] == 0} \
   {
	set zoom_factor 1
	mcidas exec "TERM Z OFF"
	mcidas exec "ZM 2"
   }

   # Set status of zoom out buttons
   if {$zoom_factor == 6} \
   {
	$buttonbar.zoomFrame.zoomIn configure \
	   -state disabled \
	   -foreground grey

	$buttonbar.zoomFrame.zoomOut configure \
	   -state normal \
	   -foreground black

	$buttonbar.zoomFrame.reset configure \
	   -state normal \
	   -foreground black
   } \
   elseif {$zoom_factor == 1} \
   {
	$buttonbar.zoomFrame.zoomIn configure \
	   -state normal \
	   -foreground black

      	$buttonbar.zoomFrame.zoomOut configure \
	   -state disabled \
	   -foreground grey

	$buttonbar.zoomFrame.reset configure \
	   -state disabled \
	   -foreground grey
   } \
   else \
   {
	$buttonbar.zoomFrame.zoomIn configure \
	   -state normal \
	   -foreground black

	$buttonbar.zoomFrame.zoomOut configure \
	   -state normal \
	   -foreground black

	$buttonbar.zoomFrame.reset configure \
	   -state normal \
	   -foreground black
   }
}

#---------------------------------------------------------------#
# initEraseButtons - create erase/toggle widgets		#
#---------------------------------------------------------------#
proc initEraseButtons {buttonbar} \
{
   global popup_help_text
   global image_on_gif
   global image_off_gif
   global graphics_on_gif
   global graphics_off_gif
   global env


   # Create button icons
   set image_on_gif [image create photo \
				-data {
R0lGODlhFgAXAPcAAAAAAAAYUgAhcwAxUgBKcwBSGABSMQBjlABXGABzSgBzcwB7vQCEhACU
YwCU3ggICBhSACEhISFzACGt/zGUADk5OUq9/2vG/6XO97Xn/9bn/+fn5///AP///////3I4
Hf//////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
//////////////////////////////7+/iH5BAEAAB0ALAAAAAAWABcAQAjlADsIHChwgUEH
DgwSHHhAAIEDBz5IXDChYkUHEzBKlCgwgIECBEJC3PjBokWCC0iSnGDhAoYLFBl8ENjwIUSD
Kk1aTLmwQ4CfAQYEKFmxJ0GSCCVaxOhgIcSIK0te2KABg4UJKZseCGngZkqdYB18WCDU5kiV
RE0uGBjhwYMCDkNu1Gm0rl2jUBNmFPuhqVG0GzFeLEoQKtoJFzJksOqAAc8OTw0LZonhZUWS
W83OzQh2wsatAp4aTKm0s9gDA0Q+PQx2LVCHq3PSFSg0AoG4htOeXDjA7U+HAEoTvlvhdgAA
wwkGBAA7
						}]

   set image_off_gif [image create photo \
				-data {
R0lGODlhFgAXAPcAAAAAAAAYUgAhcwAxUgBKcwBSGABSMQBjlABXGABzSgBzcwB7vQCEhACU
YwCU3ggICBhSACEhISFzACGt/zGUADk5OUq9/2vG/6XO97Xn/9bn/+fn5///AP///////3I4
Hf////////////////////////////////////////////////////////////8AAP//////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
//////////////////////////////7+/iH5BAEAAB0ALAAAAAAWABcAQAjuAF+86ECw4IKD
DhwcLEhQ4AEBBA4c+CBQ4IQJFV84mPCh4weCAQxklOiRYsWLDDOW/DDBwgUMFzISfBhR4sGM
Fi/qXGBSIMgAQAcEYImyA86KJRN21LnRgUyJB1RynHBhQ0aeDjocIEDAgM0FR3Uy/bBAaE2V
PV+InbCgYcUCELl6vCjT6ECGePO6rVhw4geFE5T+3WtX4MqOGy865TsT7dILGTJc/agVakad
Fi6X3Fpz4tGcFz1uFQD1INiTawN/ODCAq+XPqdsCDSDAcVqxBQdkdF0S48mCGR88AAoRwFK6
fBkXrEBAQAAARfcGBAA7
						}]

   set graphics_on_gif [image create photo \
					-data {
R0lGODlhFgAXAPcAAAAAAAAYUgAhcwAxUgBKcwBSGABSMQBjlABXGABzSgBzcwB7vQCEhACU
YwCU3ggICBhSACEhISFzACGt/zGUADk5OQB2vWvG/6XO97Xn/9bn/+fn5///AP////////8A
AP//////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////yH5BAEAAB0ALAAAAAAWABcAQAiaADsIHDjQgkEL
BBN2QDgQgMOFAAgidMiQ4UKBDztEvFiQ4EOGGTlq7CjQosOTJCkmRGgSQEWFHjOefLkSY8ST
IVuKtKhxY8eZHEFGBFmyocSiGEda5Alz4cGmMC18LGkQKs6rLg9WlagS59GeBQ16lZpVq8ql
DV3W/Ki17cy2ZLdynJpRJ9y4eNuS1LkRrUS4b7VCfSpVcMKAAAA7
							}]

   set graphics_off_gif [image create photo \
					-data {
R0lGODlhFgAXAPcAAAAAAAAYUgAhcwAxUgBKcwBSGABSMQBjlABXGABzSgBzcwB7vQCEhACU
YwCU3ggICBhSACEhISFzACGt/zGUADk5OQB2vWvG/6XO97Xn/9bn/+fn5///AP////////8A
AP//////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////yH5BAEAAB0ALAAAAAAWABcAQAiyAD986ECwYAcL
CC0YLCjwoEGBAi0AgPhBIQAACh12oHiRIICNEAlmBBnR40eRJAdqXEmxocaLFig6HAkTZcuQ
F0/mzKhQZkaOOQnK7Dhy5E2UOzX2hLi0pEeGTAt+/NhUpcuFCUc+lCmSqEiEUAcCzbkzIdeD
Y08Khag24USmMClKxLjy582BFqlm3St3L8yia4/S1IuQI8K3ERMWjBmyQ8eTcsNWzFq2cMjG
B8FKzBo2IAA7
							}]

   set erase_gif [image create photo \
			-data {
R0lGODlhFgAVAPcAAAAAAIQAAISEAISEhMbGxv8AAP//APz8/P//////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////wQguf//
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
//////////////////////////7+/v///yH5BAEAAP4ALAAAAAAWABUAQAiRAP0JHEiwIIAC
BQ4iLChQocKEAQIAIAiAwL+L/wgQGDCRoceP/hwihChxYEUABv4ZMAAgYkeQAGKCnDlTJMKW
MG+ObFmSIUqWO116rIjxH0oAAl5+BDBA40alNKOG1Hkzqk2SNamShEpRK0+uJg8+/ArTgICV
YoUutWjUrFmZa4tmRAqWYtOLGjlKbdhU796AAAA7
				   }]

   # Create outer frame
   frame $buttonbar.outerFrame
   pack $buttonbar.outerFrame \
	-side left \
	-padx 5

   # Create frame for image erase widgets
   frame $buttonbar.outerFrame.imageFrame \
	-relief ridge \
	-borderwidth 2
   pack $buttonbar.outerFrame.imageFrame \
	-side left

   # Create frame for graphics erase widgets
   frame $buttonbar.outerFrame.graphicsFrame \
	-relief ridge \
	-borderwidth 2
   pack $buttonbar.outerFrame.graphicsFrame \
	-side left

   # Create image widgets
   button $buttonbar.outerFrame.imageFrame.toggle \
	-image $image_on_gif \
	-height 21 \
	-width 21 \
   	-command "TOGGLE $buttonbar image"
   pack $buttonbar.outerFrame.imageFrame.toggle \
	-side left

   button $buttonbar.outerFrame.imageFrame.erase \
	-image $erase_gif \
	-height 21 \
	-width 21 \
	-command {ERASE_IMAGE}
   pack $buttonbar.outerFrame.imageFrame.erase \
	-side left

   # Create graphics widgets
   button $buttonbar.outerFrame.graphicsFrame.toggle \
	-image $graphics_on_gif \
	-height 21 \
	-width 21 \
	-command "TOGGLE $buttonbar graphics"
   pack $buttonbar.outerFrame.graphicsFrame.toggle \
	-side left

   button $buttonbar.outerFrame.graphicsFrame.erase \
	-image $erase_gif \
	-height 21 \
	-width 21 \
	-command {catch {exec eglite.k}}
   pack $buttonbar.outerFrame.graphicsFrame.erase \
	-side left

   # Set popup help text for erase and toggle buttons
   set popup_help_text($buttonbar.outerFrame.imageFrame.erase) \
	"Erase Image from the Current Frame"
   set popup_help_text($buttonbar.outerFrame.imageFrame.toggle) \
	"Toggle Image On/Off"
   set popup_help_text($buttonbar.outerFrame.graphicsFrame.erase) \
	"Erase Graphics from the Current Frame"
   set popup_help_text($buttonbar.outerFrame.graphicsFrame.toggle) \
	"Toggle Graphics On/Off"
}

#---------------------------------------------------------------#
# ERASE_IMAGE - Erase the image in the current frame and set
#		the cooresponding UC word to zero.
#---------------------------------------------------------------#
proc ERASE_IMAGE {} \
{
   set current_frame [UCpeek 51]

   if {[string length $current_frame] == 1} \
   {
	set current_frame 0$current_frame
   }

   set UCWord 19$current_frame
   UCpoke $UCWord 0

   catch {exec eglite.k I}
}
   

#---------------------------------------------------------------#
# TOGGLE - toggles image/graphics				#
#---------------------------------------------------------------#
proc TOGGLE {buttonbar type} \
{
   global image_on_gif
   global image_off_gif
   global graphics_on_gif
   global graphics_off_gif


   if {[string compare $type "image"] == 0} \
   {
	set status [UCpeek 55]

	if {$status == 0} \
	{
	   mcidas exec "TERM K ON"
	   $buttonbar.outerFrame.imageFrame.toggle configure \
		-relief raised \
		-image $image_on_gif
	} \
	else \
	{
	   mcidas exec "TERM K OFF"
	   $buttonbar.outerFrame.imageFrame.toggle configure \
		-relief sunken \
		-image $image_off_gif
	}
   }

   if {[string compare $type "graphics"] == 0} \
   {
	set status [UCpeek 60]

	if {$status == 0} \
	{
	   mcidas exec "TERM W ON"
	   $buttonbar.outerFrame.graphicsFrame.toggle configure \
		-relief raised \
		-image $graphics_on_gif
	} \
	else \
	{
	   mcidas exec "TERM W OFF"
	   $buttonbar.outerFrame.graphicsFrame.toggle configure \
		-relief sunken \
		-image $graphics_off_gif
	}
   }
}   

#---------------------------------------------------------------#
# initEraseButtons - create erase/toggle widgets		#
#---------------------------------------------------------------#
proc initQuickMapButton {buttonbar} \
{
   global popup_help_text
   global quick_map_image
   global env

   
   set quick_map_image [image create photo \
	-data \
{
R0lGODlhQAAaAPcAAAAAAABzvefn5///////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////////////yH5BAEAAAIALAAAAABAABoAQAj+AAUIHEiwoMGD
CBMqXCgwgEAAAARAnDjQ4cOIBCE+lBhRI8ePHgdOxHjQokWNJxuKLEjxYkeMGimGZJgwgE2L
NHN+1Imw5USTCj3O1Dm0IE6cOytyBICUp1OEQDdGPHpQ6MWdMbM+NXiz6davQadeVbnR4Eyt
IF9eRcs1I0qSAhxC9CoU5ku1dbHCJRtX5EilHJEOLQoWcF+sfA/7lci4rky7Xx3inJu4MOHC
mDPTDICyoU2GfxNevsxypOmun83CRcvaJ+SSlEOTLXpWbdqkLvcSvPmXM1PUlN3m1ntbOGGq
F5vKFVs6tFbHr3HHRc17LvXgYxdrNnxSrMfJq0Mvus5LGur139ZRN7+7t7XTqCD50r1b3P37
87+7VoU59jHbrTfFlZ9XYJW33YFOBQQAOw==
}]


   # Create frame for image erase widgets
   frame $buttonbar.outerFrame.quickMapFrame \
	-relief ridge \
	-borderwidth 2
   pack $buttonbar.outerFrame.quickMapFrame \
	-side left \
	-padx 5

   button $buttonbar.outerFrame.quickMapFrame.quickMapButton \
	-image $quick_map_image \
	-height 21 \
	-command {catch {mcidas exec "MAP X 3 DEV=NNN"}}
   pack $buttonbar.outerFrame.quickMapFrame.quickMapButton \
	-side left

   set popup_help_text($buttonbar.outerFrame.quickMapFrame.quickMapButton) \
       "Display a Simple Map"
}


#---------------------------------------------------------------#
# initButtonbar - initializes button toolbar			#
#---------------------------------------------------------------#
proc initButtonbar {buttonbar} \
{
  frame $buttonbar -relief raised -borderwidth 1

  initFileButtons $buttonbar
  initZoomButtons $buttonbar
  initEraseButtons $buttonbar
  initQuickMapButton $buttonbar

}
